<?php
include 'Schedule.class.php';
$TabDelimOutput='';
$TabDelimOutputHeader='';
$CSVDelimOutput='';
$CSVDelimOutputHeader='';
$bIsValid=false;
$ErrorMsg="";
$TeamCount=0;
$TeamList=0;
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
	<head>
		<style>
			@media screen{
				tr.noprint {
					border-style: solid;
					border-width: 5px;
				}
			}
		
			@media print {
				tr.noprint {
					visibility: collapse;
					display: none;
				}

				tr.printable {
					visibility: visible;
				}.
			}
		</style>
		<title>Schedule Generator - V 01.01.00</title>
		<script src="jquery-1.5.1.min.js" language="javascript"></script>
		<script src="jquery.cookie.js" language="javascript"></script>
		<script language="javascript">
			function updatePerTeam(){
			
				var value;	
				
				// Need to get names....
				value = document.getElementById('team_list').value;
				splitted = value.split(',');
				splitted = splitted.length;
				
				// get colors selected
				pergame = document.getElementById('teams_per_game').value;
				temp = pergame.split(',');
				pergame = temp.length;

				result = (Factorial(splitted) / (Factorial(pergame) * (Factorial(splitted-pergame))));			
				
				result = (result * pergame) / splitted;
				
				if(result > 30){
					result = 30;
				}
				

				document.getElementById("team_games").value = result;
			}
			function Factorial(In){
				var i;
				var out = 1;
				for(i=In;i>1;i--){
					out*=i;
				}
			
				return out;
			}
			$(document).ready(function() {
				if ( $.cookie('team_list') != null ) {
					$('#team_list').val($.cookie('team_list'));
				};
				if ( $.cookie('team_games') != null ) {
					$('#team_games').val($.cookie('team_games'));
				};
				if ( $.cookie('teams_per_game') != null ) {
					$('#teams_per_game').val($.cookie('teams_per_game'));
				};
				if ( $.cookie('output') != null ) {
					$('#output').val($.cookie('output'));
				};
				if ( $.cookie('TcallBefore') != null ) {
					$('#TcallBefore').val($.cookie('TcallBefore'));
				};
				if ( $.cookie('TgameLength') != null ) {
					$('#TgameLength').val($.cookie('TgameLength'));
				};
				if ( $.cookie('TbetweenGames') != null ) {
					$('#TbetweenGames').val($.cookie('TbetweenGames'));
				};

				if ( $.cookie('TstartTime') != null ) {
					$('#TstartTime').val($.cookie('TstartTime'));
				};
				$('#frm').submit(function() {
					$.cookie('team_list', $('#team_list').val());
					$.cookie('team_games', $('#team_games').val());
					$.cookie('teams_per_game', $('#teams_per_game').val());
					$.cookie('output',$('#output').val());
					$.cookie('TcallBefore',$('#TcallBefore').val());
					$.cookie('TgameLength',$('#TgameLength').val());
					$.cookie('TbetweenGames',$('#TbetweenGames').val());
					$.cookie('TstartTime',$('#TstartTime').val());
				});
			});
		</script>
	</head>
	<body>
		<table width="100%" height="100%">
		<tr class="noprint">
		<td>
		After selecting the number of teams per game or number of teams games will be automatically altered to be a single round robin. Preview before printing :).

		<form id="frm" name="frm" method="post"><input type="hidden" id="act" name="act" value="gen"></input>
		<!-- Altered --!>Team List (Comma Delimited.. 30 max):<br /> &nbsp;&nbsp;<textarea rows="4" cols="80" onchange="updatePerTeam()" id="team_list" name="team_list" ><?php echo((isset($_POST['team_list']) ? $_POST['team_list'] : 'Team Alpha, Team Beta, Team Omega, Team Smegma, Mung, Yeast Lovers, Intestinal Parasites, Ovarian Sistas, Kind Gore, Evangelical Imps, Scrotes'));?></textarea><br /> 

		Number of Games each team will play (1-30): <input id="team_games" name="team_games" value="<?php echo(isset($_POST['team_games']) ? $_POST['team_games'] : '6')?>"></input><br/>

		Colors In each Game (Comma Delimininated..  4 max)
		<textarea onchange="updatePerTeam()" id="teams_per_game" name="teams_per_game" rows="1" cols="80"><?php echo((isset($_POST['colors'])) ? $_POST['colors'] : "Red, Green"); ?></textarea><BR>
		Tournament Start Time (HH:MM:SS AM/PM)<input type="text" id="TstartTime" name="TstartTime" value="<?php DisplayPostOr("TstartTime","08:00:00 AM")?>""><BR>
		Time Between Games (HH:MM:SS)<input type="text" id="TbetweenGames" name="TbetweenGames" value="<?php DisplayPostOr("TcallBefore","0")?>""><BR>
		Game length (HH:MM:SS)<input type="text" id="TgameLength" name="TgameLength" value="<?php DisplayPostOr("TgameLength","0")?>""><BR>
		Call Game Before end(HH:MM:SS)<input type="text" id="TcallBefore" name="TcallBefore" value="<?php DisplayPostOr("TcallBefore","0")?>"><BR>	
		Output format <select name="output" id="output">
		<option value="comma" <?php OptionSelect("comma");?>> Comma Deliminated </option>
		<option value="html" <?php OptionSelect("html");?>>  HTML </option>
		<option value="table" <?php OptionSelect("table");?>> Table </option>
		<option value="tab" <?php OptionSelect("tab");?>> Tab Deliminated</option>
		</select><BR>
		<input type="submit" id="submit" value="Generate the Schedule"></input>
		</form>	
<?php 
if ( isset($_POST['act'])) {
	// we'd like a pre format..

	$TeamList=explode(',',$_POST['team_list']);
	$_POST['teams_per_game'] .= " ";
	$Colors=explode(',',preg_replace("/ /","",$_POST['teams_per_game']));	
	$PerGame = count($Colors);
	$HTMLOutput = "";
	$HTMLOutputHeader .= '  &nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;';
	$Time = $_POST['TstartTime'];

	$PreOutputCallTime = "";
	$HMTLOutputCallTime = "";
	$TabDelimOutputCallTime= "";
	$CSVDelimOUtputCallTime= "";

	$TeamCount=count($TeamList);
	if ( !isValid($PerGame) ) {
		echo('<div align="center" style="color:red;"><strong>'.$ErrorMsg.'</strong></div>');
	} else {
		$ret=GenerateSchedule($_POST['team_list'], $_POST['team_games'], $PerGame);
		//echo('Generate Schedule for <b>'.$TeamCount.'</b> Team(s):<br />');
		
		$HTMLOutputHeader = str_pad("Time",21," ",STR_PAD_LEFT);

		// setup table
		$PreOutputHeader = "<table width=\"100%\" height=\"100%\"><TR>";		
		$PreOutput = "";
		for ($iGame = 0; $iGame < count($ret); $iGame++) {
	
			$PreOutputTemp = "<TR><TD> Game ". str_pad($iGame+1,3,'0',STR_PAD_LEFT) . "</td>";
			$CSVDelimOutputTemp = "";
			$TabDelimOutputTemp = "";
			$HTMLOutputTemp = "";

			$TabDelimOutputTemp ='Game '.str_pad($iGame+1,3,'0',STR_PAD_LEFT) . "\t";
			$CSVDelimOutputTemp ='Game '.str_pad($iGame+1,3,'0',STR_PAD_LEFT).",";
			$HTMLOutputTemp = str_pad('Game '. str_pad($iGame+1,3,'0',STR_PAD_LEFT),10," ",STR_PAD_RIGHT);
	
			$PreOutputCallTime = "<TR><TD>Call Time</TD>";
			$PreOutputCallTime .= "<TD>" . CallTime($Time) . "</TD>";

			$CSVDelimOutputCallTime = "Call Time,";
			$CSVDelimOutputCallTime .= CallTime($Time) . ",";

			$TabDelimOutputCallTime = "CallTime\t";
			$TabDelimOutputCallTime .= CallTime($Time) . "\t";
	
			$HTMLOutputCallTime = "Call Time";
			$HTMLOutputCallTime .= " " . CallTime($Time);

			if ($iGame == 0) {
				$TabDelimOutputHeader="Game No \t Time\t";
				$CSVDelimOutputHeader='Game No,Time,';
				$PreOutputHeader .= '<TD> Game No </TD>';
			} 
			
			
			

			$HTMLOutputTemp .= "$Time";

			for ($iTeamSlot = 0; $iTeamSlot < count($ret[$iGame]); $iTeamSlot++ ){
				if($iTeamSlot == 0){
					$PreOutputTemp .= "<TD> $Time </TD>";
					$TabDelimOutputTemp .= "$Time\t";
					$CSVDelimOutputTemp .= "$Time,";
				}

				if($iTeamSlot == 0){
					$Target = 0;
				} else if ($iTeamSlot == count($ret[$iGame])-1){
					$Target = 2;
				} else {
					$Target = 1;
				}


				if ($iGame == 0) {
					//$TabDelimOutputHeader.='Team '.($iTeamSlot+1)."\t";
					//$CSVDelimOutputHeader.='Team '.($iTeamSlot+1).',';
				
					if($iTeamSlot == 0){
					
						$PreOutputHeader .= "<TD> Time </TD>";
					}

					$TabDelimOutputHeader.= $Colors[$iTeamSlot] . "\t";
					$CSVDelimOutputHeader.= $Colors[$iTeamSlot] . ',';
					$PreOutputHeader .= "<TD> " . $Colors[$iTeamSlot] . "</TD>";
		
				
					if($Target==0){
						$HTMLOutputHeader .= MyPad("$Colors[$iTeamSlot]",19,"&nbsp;",$Target);
					} else {
						$HTMLOutputHeader .= MyPad("$Colors[$iTeamSlot]",19,"&nbsp;",$Target);
					}			
				
					if($iTeamSlot < count($ret[$iGame])-1){
						$HTMLOutputHeader .= "vs.";
					} else {
						$HTMLOutputHeader .= "<BR>";
					}
				}
				


				if ($iTeamSlot > 0){
					$HTMLOutputTemp .= 'vs.';
					$HTMLOutputCallTime .= 'vs.';
				}

				$HTMLOutputTemp.= MyPad($ret[$iGame][$iTeamSlot],19,"&nbsp;",$Target);
				$TabDelimOutputTemp.=$ret[$iGame][$iTeamSlot]."\t";
				$CSVDelimOutputTemp.=$ret[$iGame][$iTeamSlot].",";
				$PreOutputTemp .= "<TD>" . $ret[$iGame][$iTeamSlot] . "</TD>\n";
				
				$PreOutputCallTime .= "<TD> " . $ret[$iGame][$iTeamSlot] . "</TD>";
				$HTMLOutputCallTime.= MyPad($ret[$iGame][$iTeamSlot],19,"&nbsp;",$Target);
				$TabDelimOutputCallTime.=$ret[$iGame][$iTeamSlot]."\t";
				$CSVDelimOutputCallTime.=$ret[$iGame][$iTeamSlot].",";
				
			}

			$HTMLOutputTemp.='<br />';
			$HTMLOutputCallTime .= "<BR>";	
		
			$TabDelimOutputTemp.="\n";
			$TabDelimOutputCallTime.="\n";

			$CSVDelimOutputTemp=substr($CSVDelimOutputTemp, 0, strlen($CSVDelimOutputTemp)-1);
			$CSVDelimOutputTemp.="\n";
			$CSVDelimOutputCallTime=substr($CSVDelimOutputCallTime, 0, strlen($CSVDelimOutputCallTime)-1);
			$CSVDelimOutputCallTime.="\n";

			$PreOutputTemp .= "</TR>";
			$PreOutputCallTime .= "</TR>";

			if ($iGame == 0) {
				$TabDelimOutputHeader=substr($TabDelimOutputHeader, 0, strlen($TabDelimOutputHeader)-1);
				$CSVDelimOutputHeader=substr($CSVDelimOutputHeader, 0, strlen($CSVDelimOutputHeader)-1);
				$TabDelimOutputHeader.="\n";
				$CSVDelimOutputHeader.="\n";
			} 
				$Time = NextTime($Time);
			
			if(CallGameBefore() && ($iGame > 0)){
				$PreOutput .= $PreOutputCallTime;
				$CSVDelimOutput .= $CSVDelimOutputCallTime;
				$TabDelimOutput .= $TabDelimOutputCallTime;
				$HTMLOutput .= $HTMLOutputCallTime;
			}

			$PreOutput .= $PreOutputTemp;
			$CSVDelimOutput .= $CSVDelimOutputTemp;
			$TabDelimOutput .= $TabDelimOutputTemp;
			$HTMLOutput .= $HTMLOutputTemp;


		}
	
		$PreOutput .= "</table>";	
		
		echo ('</td></tr>');
		echo ('<tr class="printable"><td>');
		
		$HTMLOutput = $HTMLOutputHeader . $HTMLOutput;

		if($_POST['output'] == "html"){
			echo("<PRE>" . $HTMLOutput . "</PRE>");
		} else if($_POST['output'] == "tab") {	
			echo('<br />Tab Delimited Output:<br /><textarea rows="30" cols="60">'.$TabDelimOutputHeader.$TabDelimOutput.'</textarea>');
			echo('<BR>');
		} else if($_POST['output'] == "comma") {	
			echo('<br />CSV Delimited Output:<br /><textarea rows="30" cols="60">'.$CSVDelimOutputHeader.$CSVDelimOutput.'</textarea>');
			echo('<BR>');
		} else if($_POST['output'] == "table") {	
			echo($PreOutputHeader ."</TR><TR>". $PreOutput);
		}

		echo('</td></tr><tr class="noprint"><td>');
		if($_POST['output'] == "html"){
			echo('<br />Tab Delimited Output:<br /><textarea rows="30" cols="60">'.$TabDelimOutputHeader.$TabDelimOutput.'</textarea>');
			echo('<BR>');
			echo('<br />CSV Delimited Output:<br /><textarea rows="30" cols="60">'.$CSVDelimOutputHeader.$CSVDelimOutput.'</textarea>');
			echo('<BR>');
			echo($PreOutputHeader ."</TR><TR>". $PreOutput);
		} else if($_POST['output'] == "tab") {	
			echo("<PRE>" . $HTMLOutput . "</PRE>");
			echo('<br />CSV Delimited Output:<br /><textarea rows="30" cols="60">'.$CSVDelimOutputHeader.$CSVDelimOutput.'</textarea>');
			echo('<BR>');
			echo($PreOutputHeader ."</TR><TR>". $PreOutput);
		} else if($_POST['output'] == "comma") {	
			echo("<PRE>" . $HTMLOutput . "</PRE>");
			echo('<br />Tab Delimited Output:<br /><textarea rows="30" cols="60">'.$TabDelimOutputHeader.$TabDelimOutput.'</textarea>');
			echo('<BR>');
			echo($PreOutputHeader ."</TR><TR>". $PreOutput);
		} else if($_POST['output'] == "table") {	
			echo("<PRE>" . $HTMLOutput . "</PRE>");
			echo('<br /><br />Tab Delimited Output:<br /><textarea rows="30" cols="60">'.$TabDelimOutputHeader.$TabDelimOutput.'</textarea>');
			echo('<BR>');
			echo('<br /><br />CSV Delimited Output:<br /><textarea rows="30" cols="60">'.$CSVDelimOutputHeader.$CSVDelimOutput.'</textarea>');
			echo('<BR>');
		}
		echo('</td></tr><tr class="printable"><td>');
	}
}
?>
		This source code has been developed under the GPL.  This means feel free to use it, alter it, etc.  But you can only use it in free software. <a href="http://www.gnu.org/licenses/gpl-3.0.html">GPL 3.0 - Click here for more info</a><br/>
		<a href="schedulewin2.zip">Click here to download the Source Code</a><br/>
		Any Questions, Comments, Complaints? schedulegen@noctusoft.com Email me!</a><br />
		Enjoy!<BR>
		original code Ricky Vega<BR>			
		Customized by tagdaplanet.com
		</td></tr></table>
	</body>
</html>
<?php 
function isValid($PerGame) {
	global $ErrorMsg;
	global $bIsValid;
	global $TeamCount;
	$ErrorMsg = "";
	$bIsValid = true;

	if ( $TeamCount > 30 ) {
		$ErrorMsg .='Team Count must be 30 or less<BR>';
		$bIsValid = false;
	}
	if ( $TeamCount == 0 ) {
		$ErrorMsg .='You gotta have teams to schedule! Remember every team name after the first, except the last must have a comma after it<BR>';
		$bIsValid = false;
	}
	if ( $TeamCount < $PerGame ) {
		$ErrorMsg.='You gotta have more teams then required per round.<BR>';
		$bIsValid = false;
	}
	if ( !is_numeric($_POST['team_games']) ) {
		$ErrorMsg.='Number of Games each team will play must be numeric<BR>';
		$bIsValid = false;
	}
	if ( $_POST['team_games'] > 30 ) {
		$ErrorMsg.='Number of Games each team will play must be 30 or less<BR>';
		$bIsValid = false;
	}
	if ( $_POST['team_games'] < 1 ) {
		$ErrorMsg.='Number of Games must be greater than 1<BR>';
		$bIsValid = false;
	}
	
	if ( $PerGame > 4 ) {
		echo "this is also firing";
		$ErrorMsg.='Number of teams in each game must be 4 or less<BR>';
		$bIsValid = false;
	}
	if ( $PerGame < 2 ) {
		$ErrorMsg.='You gotta have more than 1 team per game!<BR>';
		$bIsValid = false;
	}

	if(TestStartTime()){
		$ErrorMsg .= 'Start time is not valid, enter time in Hours:Minutes (AM or PM)<BR>';
		$bIsValid = false;
	}

	if(TestBetweenGames()){
		$ErrorMsg .= 'Time between games is not valid, enter a number greater than 0<BR>';
		$bIsValid = false;
	}

	if(TestGameLength()){
		$ErrorMsg .= 'Game length is not valid, enter a number greater then 0<BR>';
		$bIsValid = false;
	}

	if(!is_numeric($_POST['TcallBefore']) || ($_POST['TcallBefore'] < 0)){

		$ErrorMSg .= 'Call game before end is not valid, enter a number of minutes greater then 0<BR>';
		$BIsValid = false;
	}

	return $bIsValid;
}

function TestStartTime(){
	//split.. by space
	$List = explode(' ',$_POST['TstartTime']);

	// test hms
	if(!isHMSFormat($List[0])){
		return 1;
	}
	// hours < 12????
	
	$List2 = explode(":",$List[0]);
	if(($List2[0] < 0) || ($List2[0] > 12)){
		return 1;
	}

	// AM/PM
	$Hrs = strtolower($List[1]);
	if(($Hrs != "am") && ($Hrs != "pm")){
		return 1;
	}

	return 0;
}

function TestBetweenGames(){
	if(!is_numeric($_POST['TbetweenGames']) || ($_POST['TbetweenGames'] < 0)){

		return 1;
	}

	return 0;
}

function TestGameLength(){
	if(!is_numeric($_POST['TgameLength']) || ($_POST['TgameLength'] < 0)){
		return 1;
	}

	return 0;
}

function isHMSFormat($in){
	$List = explode(':',$in);
	$Hours = $List[0];
	$Minutes = $List[1];
	$Seconds = $List[2];
	
	//echo($in . count($List) . "<BR>");

	if(count($List) != 3){
		return 0;
	}

	if(!is_numeric($Hours)){
		return 0;
	}
	
	if(!is_numeric($Minutes) || ($Minutes < 0) || ($Minutes > 59)){
		return 0;
	}

	if(!is_numeric($Seconds) || ($Seconds < 0) || ($Seconds > 59)){
		return 0;
	}

	return 1;
}

function CallTime($Time){

	$AMPM[0] = "AM";
	$AMPM[1] = "PM";
	$MYAMPM = "";

	//otherwise there wouldn't be a comment in sight.

	//$List1 = explode(":",$_POST['TbetweenGames']);

	$List3 = explode(":",$_POST['TcallBefore']);
	$Temp = explode(" ",$Time);
	$HMS = explode(":",$Temp[0]);

	if(strtolower($Temp[1]) == 'am'){
		$MYAMPM = 0;
	} else {
		$MYAMPM = 1;
	}

	$HMS[0] = ($HMS[0]);
	$HMS[1] = ($HMS[1] - $_POST['TcallBefore']) - $_POST['TbetweenGames'];
	$HMS[2] = ($HMS[2]);

	$HMS[1] += floor($HMS[2]/60);
	$HMS[2] %= 60;

	$HMS[0] += floor($HMS[1]/60);
	$HMS[1] %= 60;
	

	$MYAMPM = $AMPM[((floor($HMS[0]/13)+$MYAMPM)%2)];
	$HMS[0] = $HMS[0] % 12;
	$HMS[0] = $HMS[0] == 0 ? 12: $HMS[0];

	$HMS[0] = ($HMS[0] + 12) % 12;
	$HMS[1] = ($HMS[1] + 60) % 60;
	$HMS[2] = ($HMS[2] + 60) % 60;	

	if($HMS[0] == 0){
		$HMS[0] = 12;
	}

	$HMS[0] = str_pad($HMS[0],2,'0',STR_PAD_LEFT);
	$HMS[1] = str_pad($HMS[1],2,'0',STR_PAD_LEFT);
	$HMS[2] = str_pad($HMS[2],2,'0',STR_PAD_LEFT);

	$Result = $HMS[0] . ":" . $HMS[1] . ":" . $HMS[2] . " " . $MYAMPM;

	return $Result;
}

function NextTime($Time){

	$AMPM[0] = "AM";
	$AMPM[1] = "PM";
	$MYAMPM = "";

	//otherwise there wouldn't be a comment in sight.

	//$List1 = explode(":",$_POST['TbetweenGames']);
	//$List2 = explode(":",$_POST['TgameLength']);
	$List3 = explode(":",$_POST['TcallBefore']);
	$Temp = explode(" ",$Time);
	$HMS = explode(":",$Temp[0]);

	if(strtolower($Temp[1]) == 'am'){
		$MYAMPM = 0;
	} else {
		$MYAMPM = 1;
	}

	$NoToggle = floor($HMS[0] / 12);

	$HMS[0] = $HMS[0];
	$HMS[1] = $HMS[1] + $_POST['TbetweenGames'] + $_POST['TgameLength'];
	$HMS[2] = $HMS[2];

	$HMS[1] += floor($HMS[2]/60);
	$HMS[2] %= 60;

	$HMS[0] += floor($HMS[1]/60);
	$HMS[1] %= 60;

	$MYAMPM = $AMPM[((floor($HMS[0]/12)+$MYAMPM+$NoToggle)%2)];
	$HMS[0] = $HMS[0] % 12;
	$HMS[0] = $HMS[0] == 0 ? 12: $HMS[0];
	
	$HMS[0] = str_pad($HMS[0],2,'0',STR_PAD_LEFT);
	$HMS[1] = str_pad($HMS[1],2,'0',STR_PAD_LEFT);
	$HMS[2] = str_pad($HMS[2],2,'0',STR_PAD_LEFT);

	$Result = $HMS[0] . ":" . $HMS[1] . ":" . $HMS[2] . " " . $MYAMPM;

	return $Result;
}

function CallGameBefore(){
	$List = explode(":",$_POST['TcallBefore']);
	$Total = $List[0] + $List[1] + $List[2];
	if($Total == 0){
		return 0;
	}
	
	return 1;
}


// lmr = left middle right
function MyPad($str,$num,$fill,$LMR){
	
	$len = $num - strlen($str);
	$FillString;
	$Target = 0;

	$CheapHack[0] = 0;
	$CheapHack[1] = 7;
	$CheapHack[2] = 1;
	
	for($i=0;$i<$len;$i++){
	
		if($LMR == 1){
			$FillString[$Target] .= $fill;
			$Target = ($Target+1)%2;
		} else {
			$FillString[$CheapHack[$LMR]] .= $fill;	
		}
	}
	
	$ToReturn = $fill . $FillString[0] . $str . $FillString[1] . $fill;

	echo("<!-- $ToReturn --!>");
	return $ToReturn;
}
function DisplayPostOr($PostName,$Or){
	echo((isset($_POST["$PostName"])) ? $_POST["$PostName"] : "$Or");
}
function OptionSelect($Value){
	if(isset($_POST['output'])){
		if($Value == $_POST['output']){
			echo("Selected");
		}
	}
}

?>